
FUNCTION_BLOCK DD_LoadBasicCamFromFile_DDS
	(*Used to fill the CAM structure out of an existing Basic CAM file.
	Note that the correctness of the XML-structure is not checked by this FB!*)
	VAR_INPUT
		Execute : 		BOOL := FALSE;					(*Fill the CAM structure with the file information*)
		FileName : 		STRING[80] := ''; 					(*Reference to CAM description (filename of CAM profile on the PLC)*)
		pDevice : UDINT; 	(*Pointer to the name of the PLC device on which the file is located*)
	END_VAR
	VAR_OUTPUT
		Done : 			BOOL; 							(*CAM profile has been read and structure can now be used*)
		Busy : 			BOOL; 							(*The FB is not finished and new output values are to be expected*)
		Error : 			BOOL; 							(*Signals that an error has occurred within the FB*)
		ErrorInfo : 		DD_ERROR_DDS; 				(*Error identification and instance identifier*)
	END_VAR
	VAR_IN_OUT
		BasicCam :	 	DD_BASIC_CAM_DDS;			(*Structure that is filled with the information of the file. Note that this structure will be cleared upon activation!*)
	END_VAR
	VAR
		intern : 			iDD_INTERN_LOAD_CAM_DDS; 	(*internal variable*)
	END_VAR
END_FUNCTION_BLOCK

FUNCTION_BLOCK DD_SaveBasicCamToFile_DDS
	(*Used to save a CAM structure into a CAM file.
	Note that an already existing file is overwritten!*)
	VAR_INPUT
		Execute : 		BOOL := FALSE;					(*Write information from structure to the file*)
		FileName : 		STRING[80] := ''; 					(*Reference to CAM description (filename of CAM profile on the PLC)*)
		pDevice : UDINT; 	(*Pointer to the name of the PLC device on which the file is located*)
	END_VAR
	VAR_OUTPUT
		Done : 			BOOL; 							(*CAM profile has been written to the file*)
		Busy : 			BOOL; 							(*The FB is not finished and new output values are to be expected*)
		Error : 			BOOL; 							(*Signals that an error has occurred within the FB*)
		ErrorInfo : 		DD_ERROR_DDS; 				(*Error identification and instance identifier*)
	END_VAR
	VAR_IN_OUT
		BasicCam : 		DD_BASIC_CAM_DDS;			(*Note that it is not allowed to change the content of the structure while this FB is Busy.*)
	END_VAR
	VAR
		intern : 			iDD_INTERN_SAVE_CAM_DDS; 	(*internal variable*)
	END_VAR
END_FUNCTION_BLOCK
