/* Automation Studio generated header file */
/* Do not edit ! */

#ifndef _DDS_LABCAM_
#define _DDS_LABCAM_
#ifdef __cplusplus
extern "C" 
{
#endif

#include <bur/plctypes.h>

#ifdef _SG4
		#include "DDS_Intern.h"
#endif

#ifdef _SG3
		#include "DDS_Intern.h"
#endif

#ifdef _SGC
		#include "DDS_Intern.h"
#endif

/* Constants */
#ifdef _REPLACE_CONST
 #define DD_MAX_LABEL_BLOCKS_DDS 30U
#else
 #ifndef _GLOBAL_CONST
   #define _GLOBAL_CONST _WEAK const
 #endif
 _GLOBAL_CONST unsigned short DD_MAX_LABEL_BLOCKS_DDS;
#endif




/* Datatypes and datatypes of function blocks */
typedef enum DD_LabelBlockTypes_DDS
{	DD_Labeling_Unknown_DDS,
	DD_Labeling_Init_DDS,
	DD_Labeling_Standstill_DDS,
	DD_Labeling_RelPos_DDS,
	DD_Labeling_AbsPos_DDS,
	DD_Labeling_ConstGear_DDS,
	DD_Labeling_ConstSpeed_DDS,
	DD_Labeling_StaticAlign_DDS,
	DD_Labeling_DynAlign_DDS,
	DD_Labeling_MarkAlign_DDS,
	DD_Labeling_PatternAlign_DDS
} DD_LabelBlockTypes_DDS;

typedef struct DD_AbsolutePositioning_DDS
{	float StartPlateAngle;
	float EndPlateAngle;
	float StartVel;
	float EndVel;
	float StartAcc;
	float EndAcc;
} DD_AbsolutePositioning_DDS;

typedef struct DD_ConstantGear_DDS
{	float AccGuideAngle;
	float ConstPlateAngle;
	float ConstGuideAngle;
} DD_ConstantGear_DDS;

typedef struct DD_ConstantSpeed_DDS
{	unsigned short AccTime;
	float ConstPlateAngle;
	float ConstPlateSpeed;
	unsigned short DecTime;
} DD_ConstantSpeed_DDS;

typedef struct DD_DynamicAlignment_DDS
{	float StartVel;
	float EndVel;
	float StartAcc;
	float EndAcc;
	unsigned short SegmentID;
} DD_DynamicAlignment_DDS;

typedef struct DD_Init_DDS
{	float EndPlateAngle;
	unsigned char Partition;
	unsigned short Revolutions;
} DD_Init_DDS;

typedef struct DD_RelativePositioning_DDS
{	float PlateAngle;
	float StartVel;
	float EndVel;
	float StartAcc;
	float EndAcc;
} DD_RelativePositioning_DDS;

/* Data type DD_StaticAlignment_DDS not declared. Data types with array elements whose starting indexes are not equal to zero cannot be used in ANSI C programs / libraries.*/

typedef struct DD_MarkAlignment_DDS
{	unsigned short AccTime;
	float ConstPlateAngle;
	float ConstPlateSpeed;
	unsigned short DecTime;
	unsigned char Input;
	unsigned char SensorType;
	float Threshold;
	unsigned short MinLength;
	unsigned short MaxLength;
} DD_MarkAlignment_DDS;

typedef struct DD_PatternAlignment_DDS
{	unsigned short AccTime;
	float ConstPlateAngle;
	float ConstPlateSpeed;
	unsigned short DecTime;
	unsigned char Input;
	float Threshold;
	unsigned char SubSample;
	unsigned short CheckLength;
} DD_PatternAlignment_DDS;

typedef struct DD_LABEL_BLOCK_DDS
{	float StartGuideValue;
	float DeltaGuideValue;
	enum DD_LabelBlockTypes_DDS BlockType;
	struct DD_Init_DDS Init;
	struct DD_RelativePositioning_DDS RelPos;
	struct DD_AbsolutePositioning_DDS AbsPos;
	struct DD_ConstantGear_DDS ConstGear;
	struct DD_ConstantSpeed_DDS ConstSpeed;
	struct DD_StaticAlignment_DDS StaticAlign;
	struct DD_DynamicAlignment_DDS DynAlign;
	struct DD_MarkAlignment_DDS MarkAlign;
	struct DD_PatternAlignment_DDS PatternAlign;
} DD_LABEL_BLOCK_DDS;

/* Data type DD_LABEL_CAM_DDS not declared. Data types with array elements whose starting indexes are not equal to zero cannot be used in ANSI C programs / libraries.*/

typedef struct DD_LoadLabelCamFromFile_DDS
{
	/* VAR_INPUT (analog) */
	plcstring FileName[81];
	unsigned long pDevice;
	/* VAR_OUTPUT (analog) */
	struct DD_ERROR_DDS ErrorInfo;
	/* VAR_IN_OUT (analog and digital) */
	struct DD_LABEL_CAM_DDS* LabelCam;
	/* VAR (analog) */
	struct iDD_INTERN_LOAD_CAM_DDS intern;
	/* VAR_INPUT (digital) */
	plcbit Execute;
	/* VAR_OUTPUT (digital) */
	plcbit Done;
	plcbit Busy;
	plcbit Error;
} DD_LoadLabelCamFromFile_DDS_typ;

typedef struct DD_SaveLabelCamToFile_DDS
{
	/* VAR_INPUT (analog) */
	plcstring FileName[81];
	unsigned long pDevice;
	/* VAR_OUTPUT (analog) */
	struct DD_ERROR_DDS ErrorInfo;
	/* VAR_IN_OUT (analog and digital) */
	struct DD_LABEL_CAM_DDS* LabelCam;
	/* VAR (analog) */
	struct iDD_INTERN_SAVE_CAM_DDS intern;
	/* VAR_INPUT (digital) */
	plcbit Execute;
	/* VAR_OUTPUT (digital) */
	plcbit Done;
	plcbit Busy;
	plcbit Error;
} DD_SaveLabelCamToFile_DDS_typ;



/* Prototyping of functions and function blocks */
void DD_LoadLabelCamFromFile_DDS(struct DD_LoadLabelCamFromFile_DDS* inst);
void DD_SaveLabelCamToFile_DDS(struct DD_SaveLabelCamToFile_DDS* inst);


#ifdef __cplusplus
};
#endif
#endif /* _DDS_LABCAM_ */

